import java.security.*;
import java.math.*;
import java.io.*;
import java.net.*;
import java.util.*;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.*;

import java.io.InputStream;
import java.io.PrintStream;

class Song{
	private String id,artist,title;
	public String getArtist(){
		return artist;
	}
	public String getTitle(){
		return title;
	}
	public String getId(){
		return id;
	}
	public void setArtist(String artist){
		this.artist=artist;
	}
	public void setTitle(String title){
		this.title=title;
	}	
	public void setId(String id){
		this.id=id;
	}	
	public String toString(){
		return "Titolo: "+title+"\n"+"Artista: "+artist;
	}
}

public class Last{
	private String lastfmuser, lastfmpassword, lastfmstation;
	public static void main(String[] args){
		for (int i=0;i<Integer.parseInt(args[3])/5+1;i++){
		new Last(
			args[0],	//last fm user
			args[1],	//last fm pass
			args[2]		//last fm station
		);}
	}
	public Last(String lastfmuser, String lastfmpassword, String lastfmstation){
		this.lastfmuser=lastfmuser;
		this.lastfmpassword=lastfmpassword;
		this.lastfmstation=lastfmstation;
		go();
	}
	private void go(){
		String session=loginToLastfm();
		Vector<Song> playlist=getPlaylist(session);
		for (int i=0;i<playlist.size();i++){
			System.out.println(addQuotes(escape(playlist.get(i).getId()))+","+addQuotes(escape(playlist.get(i).getTitle()))+","+addQuotes(escape(playlist.get(i).getArtist())));
		}
	}
	private String loginToLastfm(){
		String url="http://ws.audioscrobbler.com/radio/handshake.php?version=1.4." +
        "2.58240&platform=linux&platformversion=Unix%2FLinux&username=" + this.lastfmuser +
        "&passwordmd5=" + getMD5Hash(this.lastfmpassword).toLowerCase()+"&language=en";
		String page=getURLContent(url);
		return ((page.split("\n"))[0].split("="))[1].trim();
	}
	private Vector<Song> getPlaylist(String session){
		String url="http://ws.audioscrobbler.com/radio/adjust.php?session=" + session + "&url=" + this.lastfmstation;
		String page=getURLContent(url);
		url="http://ws.audioscrobbler.com/radio/xspf.php?sk=" + session + "&discovery=0&desktop=1.4.2.58240";
		page=getURLContent(url);
		Vector<Song> songs=new Vector<Song>();
		//Parse XML
		try {
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			DocumentBuilder db = dbf.newDocumentBuilder();
			InputSource is = new InputSource();
			is.setCharacterStream(new StringReader(page));
			Document doc = db.parse(is);
			doc.getDocumentElement().normalize();
			NodeList nodeLst = doc.getElementsByTagName("track");
			for (int s = 0; s < nodeLst.getLength(); s++) {
				Song song=new Song();
				Node fstNode = nodeLst.item(s);
				if (fstNode.getNodeType() == Node.ELEMENT_NODE) {
					Element fstElmnt = (Element) fstNode;
					//Id
					NodeList fstNmElmntLst = fstElmnt.getElementsByTagName("id");
					Element fstNmElmnt = (Element) fstNmElmntLst.item(0);
					NodeList fstNm = fstNmElmnt.getChildNodes();
					song.setId(((Node) fstNm.item(0)).getNodeValue());
					//Artist
					fstNmElmntLst = fstElmnt.getElementsByTagName("creator");
					fstNmElmnt = (Element) fstNmElmntLst.item(0);
					fstNm = fstNmElmnt.getChildNodes();
					song.setArtist(((Node) fstNm.item(0)).getNodeValue());
					//Title
					fstNmElmntLst = fstElmnt.getElementsByTagName("title");
					fstNmElmnt = (Element) fstNmElmntLst.item(0);
					fstNm = fstNmElmnt.getChildNodes();
					song.setTitle(((Node) fstNm.item(0)).getNodeValue());					
				}
				songs.add(song);
			}
		}catch(Exception e){
			e.printStackTrace();
		}		
		return songs;
	}
	private static String hex(char ch) {
        return Integer.toHexString(ch).toUpperCase();
    }
	private static String escape(String str){
		boolean escapeSingleQuote=false;
		String ret="";
        int sz;
        sz = str.length();
        for (int i = 0; i < sz; i++) {
            char ch = str.charAt(i);

            // handle unicode
            if (ch > 0xfff) {
                ret+="\\u" + hex(ch);
            } else if (ch > 0xff) {
                ret+="\\u0" + hex(ch);
            } else if (ch > 0x7f) {
                ret+="\\u00" + hex(ch);
            } else if (ch < 32) {
                switch (ch) {
                    case '\b':
                        ret+='\\';
                        ret+='b';
                        break;
                    case '\n':
                        ret+='\\';
                        ret+='n';
                        break;
                    case '\t':
                        ret+='\\';
                        ret+='t';
                        break;
                    case '\f':
                        ret+='\\';
                        ret+='f';
                        break;
                    case '\r':
                        ret+='\\';
                        ret+='r';
                        break;
                    default :
                        if (ch > 0xf) {
                            ret+="\\u00" + hex(ch);
                        } else {
                            ret+="\\u000" + hex(ch);
                        }
                        break;
                }
            } else {
                switch (ch) {
                    case '\'':
                        if (escapeSingleQuote) {
                          ret+='\\';
                        }
                        ret+='\'';
                        break;
                    case '"':
                        ret+='\\';
                        ret+='"';
                        break;
                    case '\\':
                        ret+='\\';
                        ret+='\\';
                        break;
                    default :
                        ret+=ch;
                        break;
                }
            }
        }
		return ret;
	}
	private static String addQuotes(String s){
		return "\""+s+"\"";
	}	
	private static String getMD5Hash(String s){
		try{
			MessageDigest m = MessageDigest.getInstance("MD5");
			byte[] data = s.getBytes(); 
			m.update(data,0,data.length);
			BigInteger i = new BigInteger(1,m.digest());
			return String.format("%1$032X", i);
		}catch(Exception e){
			e.printStackTrace();
		}
		return null;
	}
	private static String getURLContent(String url_){
		try{
			URL url = new URL(url_);
			BufferedReader in = new BufferedReader(
						new InputStreamReader(
						url.openStream()));
			String temp;
			String inputLine="";

			while ((temp = in.readLine()) != null)
				inputLine+=temp+"\n";

			in.close();
			return inputLine;
		}catch(Exception e){
			e.printStackTrace();
		}
		return null;
	}
}